import { Source, Loader } from '@graphql-tools/utils';
import { UnnormalizedTypeDefPointer, LoadTypedefsOptions } from '@graphql-tools/load';
import { GraphQLSchema, DocumentNode } from 'graphql';
import { MiddlewareFn } from './helpers/utils';
declare type Pointer = UnnormalizedTypeDefPointer | UnnormalizedTypeDefPointer[];
declare type Options = Partial<LoadTypedefsOptions>;
export declare type SchemaOutput = 'GraphQLSchema' | 'DocumentNode' | 'string';
export declare class LoadersRegistry {
    private _loaders;
    private _middlewares;
    private readonly cwd;
    constructor({ cwd }: {
        cwd: string;
    });
    register(loader: Loader): void;
    use(middleware: MiddlewareFn<DocumentNode>): void;
    loadTypeDefs(pointer: Pointer, options?: Options): Promise<Source[]>;
    loadTypeDefsSync(pointer: Pointer, options?: Options): Source[];
    loadDocuments(pointer: Pointer, options?: Options): Promise<Source[]>;
    loadDocumentsSync(pointer: Pointer, options?: Options): Source[];
    loadSchema(pointer: Pointer): Promise<GraphQLSchema>;
    loadSchema(pointer: Pointer, out: 'string'): Promise<GraphQLSchema>;
    loadSchema(pointer: Pointer, out: 'DocumentNode'): Promise<DocumentNode>;
    loadSchema(pointer: Pointer, out: 'GraphQLSchema'): Promise<GraphQLSchema>;
    loadSchemaSync(pointer: Pointer): GraphQLSchema;
    loadSchemaSync(pointer: Pointer, out: 'string'): GraphQLSchema;
    loadSchemaSync(pointer: Pointer, out: 'DocumentNode'): DocumentNode;
    loadSchemaSync(pointer: Pointer, out: 'GraphQLSchema'): GraphQLSchema;
    private createOptions;
    private transformSchemaSources;
    private castSchema;
}
export {};
//# sourceMappingURL=loaders.d.ts.map